﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class AutoFixForm : Form
    {
        public AutoFixForm()
        {
            InitializeComponent();
        }

        private void auto_fix_form_Load(object sender, EventArgs e)
        {
            russian_combobox_.SelectedIndex = 0;
        }

        private void russian_combobox__SelectedIndexChanged(object sender, EventArgs e)
        {
            update_russian_sample();
        }

        private void update_russian_sample()
        {
            Transcription trans = new Transcription();
            trans.add_transcription(Transcription.russian_transcriptions_[russian_combobox_.SelectedIndex]);
        
            string sample = "энциклопедия";
            string transcribed_sample = trans.transcribe(sample);
            
            russian_sample_label_.Text = string.Format("Przykład: \"{0}\" -> \"{1}\"", sample, transcribed_sample);
        }

        private void russian_checkbox__CheckedChanged(object sender, EventArgs e)
        {
            russian_combobox_.Enabled = russian_checkbox_.Checked;
        }

        private void length_checkbox__CheckedChanged(object sender, EventArgs e)
        {
            length_textbox_.Enabled = length_checkbox_.Checked;
        }

        private void ok_button__Click(object sender, EventArgs e)
        {
            max_length_ = 0;

            if (length_checkbox_.Checked)
            {
                if (!uint.TryParse(length_textbox_.Text, out max_length_) || max_length_ < 2)
                {
                    MessageBox.Show(this, "Podaj prawidłową maksymalną długość.", "Błąd", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
            }

            DialogResult = System.Windows.Forms.DialogResult.OK;
        }

        public uint max_length_;
    }
}
