﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    class Transcription
    {
        public static string polish_transcription_ = @"ąa ćc ęe łl ńn óo śs żz źz ĄA ĆC ĘE ŁL ŃN ÓO ŚS ŻZ ŹZ";
        public static string[] russian_transcriptions_ = {
            // Polska z polskimi literami
            @"аa бb вw гg дd еje ёjo жż зz иi йj кk лł мm нn оo пp рr сs тt уu фf хch цc чcz шsz щszcz ъ ыy ь эe юju яja АA БB ВW ГG ДD ЕJE ЁJO ЖŻ ЗZ ИI ЙJ КK ЛŁ МM НN ОO ПP РR СS ТT УU ФF ХCH ЦC ЧCZ ШSZ ЩSZCZ Ъ ЫY Ь ЭE ЮJU ЯJA",
            // Polska bez polskich liter
            @"аa бb вw гg дd еje ёjo жz зz иi йj кk лl мm нn оo пp рr сs тt уu фf хch цc чcz шsz щszcz ъ ыy ь эe юju яja АA БB ВW ГG ДD ЕJE ЁJO ЖZ ЗZ ИI ЙJ КK ЛL МM НN ОO ПP РR СS ТT УU ФF ХCH ЦC ЧCZ ШSZ ЩSZCZ Ъ ЫY Ь ЭE ЮJU ЯJA",
            // Angielska
            @"аa бb вv гg дd еye ёyo жzh зz иi йy кk лl мm нn оo пp рr сs тt уu фf хkh цts чch шsh щshch ъ ыy ь эe юyu яya АA БB ВV ГG ДD ЕYE ЁYO ЖZH ЗZ ИI ЙY КK ЛL МM НN ОO ПP РR СS ТT УU ФF ХKH ЦTS ЧCH ШSH ЩSHCH Ъ ЫY Ь ЭE ЮYU ЯYA",
        };

        public Transcription()
        {
        }

        public void add_transcription(string transcription)
        {
            int i = 0, len = transcription.Length;
            StringBuilder sb = new StringBuilder();
            for (;;)
            {
                while (i < len && transcription[i] == ' ')
                    ++i;
                if (i == len)
                    break;

                char src = transcription[i++];
                Debug.Assert(src != ' ');

                while (i < len && transcription[i] != ' ')
                    sb.Append(transcription[i++]);

                append_item(src, sb.ToString());
                sb.Clear();
            }
        }

        public string transcribe(string s)
        {
            StringBuilder sb = new StringBuilder();
            foreach (char ch in s)
            {
                int index = (int)(ushort)ch;
                if (index < num_used_items_)
                    sb.Append(items_[index].dst_);
                else
                    sb.Append(ch);
            }
            return sb.ToString();
        }

        private void append_item(char src, string dst)
        {
            int index = (int)(ushort)src;
            if (index >= num_used_items_)
            {
                for (int i = num_used_items_; i < index; ++i)
                    items_[i].dst_ = ((char)(ushort)i).ToString();
                num_used_items_ = index + 1;
            }
            items_[index].dst_ = dst;
        }

        private struct Item
        {
            public string dst_;
        };

        private Item[] items_ = new Item[0x10000];
        private int num_used_items_ = 0;
    };
}
